CODE_PATHS := scientist

## default python build
PYTHON_VERSION				?= 3.10

# Originally CI_PROJECT_NAME came from the CI, but it is safer if this comes directly from pyproject.toml
CI_PROJECT_NAME				:= $(shell grep -i name pyproject.toml | head -1 | awk -F'"' '{print $$2}' | tr "[A-Z]" "[a-z]" | tr "_" "-")
CI_COMMIT_REF_NAME			?= $(shell git symbolic-ref --short -q HEAD)
CI_COMMIT_REF_NAME			:= $(subst /,-,$(CI_COMMIT_REF_NAME))
CI_COMMIT_REF_SLUG 			?= $(shell echo "${CI_COMMIT_REF_NAME}" | cut -c -63 | sed -e 's/[^a-zA-Z0-9]/-/g' | tr '[:upper:]' '[:lower:]')
CI_COMMIT_SHORT_SHA			?= $(shell git rev-parse --short=8 HEAD)
CURRENT_LOCATION			?= $(shell pwd)
CI_DOCKER_BUILD_ARGS		?=

PYPI_URL					?= https://artifactory.aws.gel.ac/artifactory/api/pypi/pypi/simple

CI_REGISTRY					?= registry.gitlab.com
CI_REGISTRY_IMAGE			?= ${CI_REGISTRY}/https://gitlab.com/opensourcelab/devices/humans/scientist
DOCKER_IMAGE_TAG			?= ${CI_REGISTRY_IMAGE}/${CI_COMMIT_REF_SLUG}:py${PYTHON_VERSION}-${CI_COMMIT_SHORT_SHA}
DOCKER_IMAGE_CACHE			?= ${CI_REGISTRY_IMAGE}:py${PYTHON_VERSION}-cache

.PHONY: build test

help:	## Prints this help/overview message
	@awk 'BEGIN {FS = ":.*?## "} /^[a-z0-9_-]+:.*?## / {printf "\033[36m%-17s\033[0m %s\n", $$1, $$2}' $(MAKEFILE_LIST)

_CMD_DOCKER_BUILD := \
	docker buildx build \
		${CI_DOCKER_BUILD_ARGS}

## construct the docker image with the git branch inc. into the tag
.build_${PYTHON_VERSION}: Dockerfile scientist clean__py
	${_CMD_DOCKER_BUILD} \
		--platform linux/amd64 \
		--build-arg PYTHON_BASE=${PYTHON_VERSION} \
		--build-arg PYPI_URL=${PYPI_URL} \
		--cache-from type=registry,ref=${DOCKER_IMAGE_CACHE} \
		--cache-to type=registry,ref=${DOCKER_IMAGE_CACHE},mode=max \
		--tag ${DOCKER_IMAGE_TAG} \
		--target test \
		.
	touch $@

build: .build_${PYTHON_VERSION} ## build local python3.10 image. Define PYTHON_VERSION to select other python version.

push: build
	docker push ${DOCKER_IMAGE_TAG}

pull:
	docker pull ${DOCKER_IMAGE_TAG} || echo "No pre-made image available"

test:	## run pytest on mounted-in tests (change tests, no rebuild!)
	mkdir -p $(CURRENT_LOCATION)/bin && \
	docker run \
			--platform linux/amd64 \
			--volume $(CURRENT_LOCATION)/bin/:/${CODE_PATHS}/bin/ \
			--volume $(CURRENT_LOCATION):/${CODE_PATHS}:rw \
			${DOCKER_IMAGE_TAG} \
			inv test --coverage

test_shell:	## enter test docker image Bash
	mkdir -p $(CURRENT_LOCATION)/bin && \
		docker run -it \
				--platform linux/amd64 \
				--volume $(CURRENT_LOCATION)/bin/:/${CODE_PATHS}/bin/ \
				--volume $(CURRENT_LOCATION):/${CODE_PATHS}:rw \
				${DOCKER_IMAGE_TAG} \
				/bin/bash

# cleaning up --------------------------------------------------------
clean: clean__docker clean__py clean__reports

clean__py:	## clean python temp files
	find . -iname *.pyc -delete
	find . -iname __pycache__ -delete
	find . -iname .cache -delete

clean__docker:	## Clean up all docker images generated by this repo
	rm -rf .*sentinel
	for image in \
		$$(docker images --format "{\{.Repository}\}:{\{.Tag}\}\t{\{.ID}\}" | grep -e "${DOCKER_IMAGE_NAMESPACE}" | awk '{print $$2}'); do \
		docker rmi -f $$image; \
	done

clean__reports:
	rm -rf ${PATH_REPORTS}

